﻿<AML>
 <Item type="Method" id="2AA30C770D1440819A95BE9EB2DD1B6D" action="add">
  <execution_allowed_to keyed_name="World" type="Identity">A73B655731924CD0B027E4F4D5FCC0A9</execution_allowed_to>
  <method_code><![CDATA[            /* *****************************************************************************
            Method Name:			acc_aging_report?
            Created By/Company:		SolidCAD 
            Creation Date:			2018-01-23
            Description:
                Getting Required Information for Report.

            Hooks:
                Type:		Form : acc_aging_report
                Event:		button0 ( onClick )
                Called by:	acc_aging_report_call

            Inputs:
                Customer Name ,
                Statement Date ,
                Currency ,
                erp_company

            Revisions:
                Rev Date		Modified By			Description
                YYYY-MM-DD		***					Initial creation
            ***************************************************************************** */

            //WARNING: DO NOT FORGET TO DISABLE THIS IN A PRODUCTION ENVIRONMENT!!!
            //if(System.Diagnostics.Debugger.Launch()) System.Diagnostics.Debugger.Break();

            string MethodName = "acc_aging_report?";

            //***** GRANT IDENTITY PRIVILEGES
            // grantIdentityPrivileges("Super User"); // If this is enabled always revoke the privileges in the Finally below.
            //*******************************
            Innovator myInnovator = this.getInnovator();
            Item result = this; // default return value.

            try
            {
                var acc_customer_id = this.getProperty("acc_customer_id", "");
                var acc_report_currency = this.getProperty("acc_report_currency", "");
                var acc_statement_date = this.getProperty("acc_statement_date", "");
                var erp_company_id = this.getProperty("erp_company", "");

                var name_condition = "";
                var name_condition1 = "";
                var name_condition2 = "";
                var name_condition3 = "";
                string query = "";
                string query1 = "";

                var receivable_date = "";

                DateTime d_receivable_date = new DateTime();              
                string con_statement_date = acc_statement_date;

                /* BETWEEN statemment date and Last Receivable */

                name_condition1 = " acc_journal_header.ACC_CUSTOMERID= '" + acc_customer_id + "' and Convert(Date,innovator.ConvertToLocal(ACC_ACCOUNTSRECEIVABLE.ACC_DATE,DEFAULT),111) <=CONVERT(Date,'" + con_statement_date + "',111)";

                query1 = "select TOP 1 innovator.ConvertToLocal(acc_journal_header.ACC_DATE,DEFAULT) from  innovator.ACC_ACCOUNTSRECEIVABLE " +
                "inner join  innovator.acc_journal_header on acc_journal_header.acc_refno=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO where " + name_condition1 + "ORDER BY acc_journal_header.ACC_DATE DESC";
                Item _get_data_date = myInnovator.applySQL(query1);
                var _get_data_date_count = _get_data_date.getItemCount();
                if (_get_data_date_count > 0)
                {
                    for (int i = 0; i < _get_data_date_count; i++)
                    {
                        var j = i + 1;
                        var _get_data_date_result = _get_data_date.getItemByIndex(i);
                        d_receivable_date = DateTime.Parse(_get_data_date_result.getProperty("acc_date"));
                        d_receivable_date = new DateTimeOffset(d_receivable_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                        receivable_date = d_receivable_date.ToString("yyyy-MM-dd hh:mm:ss");

                    }
                }

                if (acc_customer_id != "")
                {
                    name_condition = " and CUSTOMER.id= '" + acc_customer_id + "' and  Convert(Date,innovator.ConvertToLocal(acc_journal_header.acc_date,DEFAULT),111)  > CONVERT(Date,'" + receivable_date + "',111) AND "
                    + " Convert(Date,innovator.ConvertToLocal(acc_journal_header.acc_date,DEFAULT),111)   <= CONVERT(Date,'" + con_statement_date + "',111)";
                    name_condition2 = " and CUSTOMER.id= '" + acc_customer_id + "' and Convert(Date,innovator.ConvertToLocal(acc_journal_header.acc_date,DEFAULT),111) <=CONVERT(Date,'" + receivable_date + "',111)";
                    name_condition3 = " and CUSTOMER.ID= '" + acc_customer_id + "' and " +
                       " Convert(Date,innovator.ConvertToLocal(acc_journal_header.acc_date,DEFAULT),111)  " + " <= CONVERT(Date,'" + receivable_date + "',111)";
                }
                if (acc_report_currency == "USD")
                {
                    query = "select Max(innovator.ConvertToLocal(acc_journal_header.ACC_DATE,DEFAULT)) as acc_date,''  as invoice_no,'Balance As Of ' as acc_description ,(select sum(acc_debit) as acc_debit from innovator.acc_journal_header " +
                 " inner join innovator.ACC_JOURNAL_DETAILS " +
                 " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                 " inner join innovator.SOP_SALE_INVOICE on acc_journal_header.acc_refno=SOP_SALE_INVOICE.SOP_INVOICE_NO " +
                 " inner join innovator.CUSTOMER on CUSTOMER.ID=SOP_SALE_INVOICE.SOP_CUSTOMER where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null " + name_condition3 +
                 " and Convert(Date,DATEADD(ms, DATEDIFF(ms, GETUTCDATE(), GETDATE()),FORMAT(CAST (SOP_SALE_INVOICE.SOP_INVOICE_DATE as datetime),'yyyy/MM/dd h:mm:s tt')),111) <=CONVERT(Date,'" + con_statement_date + "',111)) as acc_debit " +
                 ",(select sum(acc_credit) as acc_credit from innovator.acc_journal_header " +
                 " inner join innovator.ACC_JOURNAL_DETAILS " +
                 " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                 " inner join innovator.ACC_ACCOUNTSRECEIVABLE on acc_journal_header.acc_refno=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO inner join innovator.CUSTOMER on CUSTOMER.ID=acc_journal_header.ACC_CUSTOMERID " +
                 " where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null " + name_condition2 +
                 " and Convert(Date,DATEADD(ms, DATEDIFF(ms, GETUTCDATE(), GETDATE()),FORMAT(CAST (ACC_ACCOUNTSRECEIVABLE.acc_date as datetime),'yyyy/MM/dd h:mm:s tt')),111)  <= CONVERT(Date,'" + con_statement_date + "',111) ) as acc_credit " +
                 " from innovator.acc_journal_header " +
                 " inner join innovator.ACC_JOURNAL_DETAILS " +
                 " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                 " inner join innovator.ACC_ACCOUNTSRECEIVABLE on acc_journal_header.acc_refno=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO inner join innovator.CUSTOMER on CUSTOMER.ID=acc_journal_header.ACC_CUSTOMERID " +
                 " where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null " + name_condition2 +
                 " union " +
                 " select acc_journal_header.ACC_DATE as acc_date,SOP_INVOICE_NO as invoice_no,ACC_JOURNAL_DETAILS.ACC_DESCRIPTION as acc_description,sum(ACC_JOURNAL_DETAILS.acc_debit) as acc_debit,'0' as acc_credit  from innovator.acc_journal_header " +
                 " inner join innovator.ACC_JOURNAL_DETAILS " +
                 " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                 " inner join innovator.SOP_SALE_INVOICE on acc_journal_header.acc_refno=SOP_SALE_INVOICE.SOP_INVOICE_NO " +
                 " inner join innovator.CUSTOMER on CUSTOMER.ID=SOP_SALE_INVOICE.SOP_CUSTOMER " +
                 " where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null  and ACC_JOURNAL_DETAILS.ACC_SYSTEMACCOUNTID='Account Receivable' " + name_condition +
                 " group by SOP_INVOICE_NO,acc_journal_header.ACC_DATE,ACC_DESCRIPTION " +
                 "order by invoice_no ASC ";

                }
                else
                {
                    query = "select Max(innovator.ConvertToLocal(acc_journal_header.ACC_DATE,DEFAULT)) as acc_date,''  as invoice_no,'Balance As Of ' as acc_description ,(select sum(acc_sg_debit) as acc_debit from innovator.acc_journal_header " +
                " inner join innovator.ACC_JOURNAL_DETAILS " +
                " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                " inner join innovator.SOP_SALE_INVOICE on acc_journal_header.acc_refno=SOP_SALE_INVOICE.SOP_INVOICE_NO " +
                " inner join innovator.CUSTOMER on CUSTOMER.ID=SOP_SALE_INVOICE.SOP_CUSTOMER where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null " + name_condition3 +
                " and Convert(Date,DATEADD(ms, DATEDIFF(ms, GETUTCDATE(), GETDATE()),FORMAT(CAST (SOP_SALE_INVOICE.SOP_INVOICE_DATE as datetime),'yyyy/MM/dd h:mm:s tt')),111)<= CONVERT(Date,'" + con_statement_date + "',111)) as acc_debit " +
                ",(select sum(acc_credit) as acc_credit from innovator.acc_journal_header " +
                " inner join innovator.ACC_JOURNAL_DETAILS " +
                " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                " inner join innovator.ACC_ACCOUNTSRECEIVABLE on acc_journal_header.acc_refno=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO inner join innovator.CUSTOMER on CUSTOMER.ID=acc_journal_header.ACC_CUSTOMERID " +
                " where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null " + name_condition2 +
                "and Convert(Date,DATEADD(ms, DATEDIFF(ms, GETUTCDATE(), GETDATE()),FORMAT(CAST (ACC_ACCOUNTSRECEIVABLE.acc_date as datetime),'yyyy/MM/dd h:mm:s tt')),111)  > CONVERT(Date,'" + receivable_date + "',111) ) as acc_credit " +
                " from innovator.acc_journal_header " +
                " inner join innovator.ACC_JOURNAL_DETAILS " +
                " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                " inner join innovator.ACC_ACCOUNTSRECEIVABLE on acc_journal_header.acc_refno=ACC_ACCOUNTSRECEIVABLE.ACC_REFERENCE_NO inner join innovator.CUSTOMER on CUSTOMER.ID=acc_journal_header.ACC_CUSTOMERID " +
                " where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null " + name_condition2 +
                " union " +
                " select acc_journal_header.ACC_DATE  as acc_date,SOP_INVOICE_NO as invoice_no,ACC_JOURNAL_DETAILS.ACC_DESCRIPTION as acc_description,sum(ACC_JOURNAL_DETAILS.acc_sg_debit) as acc_debit,'0' as acc_credit  from innovator.acc_journal_header " +
                " inner join innovator.ACC_JOURNAL_DETAILS " +
                " on acc_journal_header.id=ACC_JOURNAL_DETAILS.SOURCE_ID " +
                " inner join innovator.SOP_SALE_INVOICE on acc_journal_header.acc_refno=SOP_SALE_INVOICE.SOP_INVOICE_NO " +
                " inner join innovator.CUSTOMER on CUSTOMER.ID=SOP_SALE_INVOICE.SOP_CUSTOMER " +
                " where acc_journal_header.ACC_SOP_VOUCHER_REFERENCE <> '' and  acc_journal_header.ACC_SOP_VOUCHER_REFERENCE is not null  and ACC_JOURNAL_DETAILS.ACC_SYSTEMACCOUNTID='Account Receivable' " + name_condition +
                " group by SOP_INVOICE_NO,acc_journal_header.ACC_DATE,ACC_DESCRIPTION " +
                "order by invoice_no ASC ";
                }                
                var clear_report_data = myInnovator.applySQL("DELETE FROM innovator.acc_aging_report");
                Item _get_data = myInnovator.applySQL(query);

                var _get_data_count = _get_data.getItemCount();             
                int days = 0;
                decimal temp_total = 0;
                decimal diff_debit_credit = 0;
                if (_get_data_count > 0)
                {
                    for (int i = 0; i < _get_data_count; i++)
                    {
                        var j = i + 1;
                        var _get_data_result = _get_data.getItemByIndex(i);
                        var acc_date = _get_data_result.getProperty("acc_date");
                        if (acc_date == null || acc_date == "")
                        {

                        }
                        else
                        {
                            DateTime dt_acc_date = DateTime.Parse(acc_date);
                            dt_acc_date = new DateTimeOffset(dt_acc_date, TimeSpan.FromHours(0)).ToLocalTime().DateTime;
                            var local_acc_date = dt_acc_date.ToString("dd-MM-yy");
                            DateTime dt_acc_statement_date = DateTime.Parse(acc_statement_date);
                            TimeSpan difference = dt_acc_statement_date - dt_acc_date;
                            days = Convert.ToInt32(difference.TotalDays);

                            var description_acc_date = "( " + local_acc_date + " )";

                            var sop_owing_amount = _get_data_result.getProperty("acc_debit");
                            var sop_invoice_no = _get_data_result.getProperty("invoice_no");
                            var acc_description = _get_data_result.getProperty("acc_description");
                            var acc_debit = _get_data_result.getProperty("acc_debit");
                            var acc_credit = _get_data_result.getProperty("acc_credit");

                            Item acc_aging_report = myInnovator.newItem("acc_aging_report", "add");
                            acc_aging_report.setProperty("acc_customer_name", acc_customer_id);
                            acc_aging_report.setProperty("acc_invoice_date", local_acc_date);
                            if (sop_invoice_no == "")
                            {
                                if (acc_debit == null)
                                {
                                    acc_aging_report.setProperty("acc_temp_total", "0.00");
                                }
                                if (acc_debit != null)
                                {
                                    diff_debit_credit = Convert.ToDecimal(acc_debit) - Convert.ToDecimal(acc_credit);
                                    acc_aging_report.setProperty("acc_temp_total", diff_debit_credit.ToString());
                                }
                                temp_total = temp_total + Convert.ToDecimal(diff_debit_credit.ToString());
                                acc_description = acc_description + description_acc_date;
                                acc_aging_report.setProperty("acc_description", acc_description);
                                if (days >= 0 && days <= 30)
                                {
                                    acc_aging_report.setProperty("acc_current", diff_debit_credit.ToString());
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else if (days > 30 && days <= 45)
                                {
                                    acc_aging_report.setProperty("acc_greaterthanthirty", diff_debit_credit.ToString());
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else if (days > 45 && days <= 60)
                                {
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", diff_debit_credit.ToString());
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else if (days > 60 && days <= 90)
                                {
                                    acc_aging_report.setProperty("acc_greaterthansixty", diff_debit_credit.ToString());
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else
                                {
                                    acc_aging_report.setProperty("acc_greaterthanninty", diff_debit_credit.ToString());
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                }
                            }
                            else
                            {
                                acc_aging_report.setProperty("acc_receivable_amount", sop_owing_amount);
                                temp_total = temp_total + Convert.ToDecimal(sop_owing_amount);
                                acc_aging_report.setProperty("acc_temp_total", temp_total.ToString());
                                acc_aging_report.setProperty("acc_description", acc_description);
                                if (days >= 0 && days <= 30)
                                {
                                    acc_aging_report.setProperty("acc_current", sop_owing_amount);
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else if (days > 30 && days <= 45)
                                {
                                    acc_aging_report.setProperty("acc_greaterthanthirty", sop_owing_amount);
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else if (days > 45 && days <= 60)
                                {
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", sop_owing_amount);
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else if (days > 60 && days <= 90)
                                {
                                    acc_aging_report.setProperty("acc_greaterthansixty", sop_owing_amount);
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanninty", "0.00");
                                }
                                else
                                {
                                    acc_aging_report.setProperty("acc_greaterthanninty", sop_owing_amount);
                                    acc_aging_report.setProperty("acc_greaterthanfortyfive", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthansixty", "0.00");
                                    acc_aging_report.setProperty("acc_greaterthanthirty", "0.00");
                                    acc_aging_report.setProperty("acc_current", "0.00");
                                }
                            }
                            acc_aging_report.setProperty("acc_invoice_no", sop_invoice_no);
                            acc_aging_report.setProperty("erp_company", erp_company_id);
                            acc_aging_report.setProperty("acc_currency", acc_report_currency);
                            acc_aging_report.setProperty("acc_statement_date", acc_statement_date);
                            acc_aging_report.setProperty("acc_description", acc_description);

                            acc_aging_report = acc_aging_report.apply();
                            int icount = acc_aging_report.getItemCount();
                            if (acc_aging_report.isError())
                            {
                                return myInnovator.newError("Error While Adding aging report.");
                            }
                        }

                    }
                }
            }
            catch (System.Exception ex)
            {
                result = myInnovator.newError(string.Format("SYSTEM EXCEPTION in method {0}\n{1}", MethodName, ex.Message));
                ////result.setErrorCode("0");		//only use if this method is called from another method
            }
            finally
            {
                //**** REVOKE IDENTITY PRIVILEGES
                // revokeIdentityPrivileges();
                //*******************************
            }

            return result;
        }
        /// <summary>
        /// This section is to allow the current method to assume the privileges of a specific identity.
        /// For instance calling: grantIdentityPrivileges("Aras PLM"); will allow this method all of the
        /// rights of the Aras PLM identity.
        /// The revokeIdentityPrivileges() method will removed the privileges added for this method. It
        /// must be called from before the method exits. Most likely in the Finally of the main method code.
        /// If different identity privileges must be granted a second time within the same method, first use
        /// revokeIdentityPrivileges() to remove the first privileges before granting new ones.
        /// </summary>

        private string AssignedIdentity;

        /// <summary>
        /// If required, call this helper function to run this method as another Identity. 
        /// Ensure that you call the revokeIdentityPrivileges helper function in the 
        /// finally block to revoke the Identity privilege when this method completes.
        /// </summary>
        public void grantIdentityPrivileges(string assignedIdent)
        {
            if (!string.IsNullOrEmpty(AssignedIdentity))
            {
                revokeIdentityPrivileges();
            }

            Aras.Server.Security.Identity secIdentity = Aras.Server.Security.Identity.GetByName(assignedIdent);
            if (Aras.Server.Security.Permissions.GrantIdentity(secIdentity))
            {
                AssignedIdentity = assignedIdent;
            }
        }

        /// <summary>
        /// If you granted security privileges, then you need to ensure that you revoke the privilege.
        /// </summary>
        public void revokeIdentityPrivileges()
        {
            if (AssignedIdentity != null)
            {
                Aras.Server.Security.Permissions.RevokeIdentity(Aras.Server.Security.Identity.GetByName(AssignedIdentity));
                AssignedIdentity = null;
            }          ]]></method_code>
  <method_type>C#</method_type>
  <name>acc_aging_report</name>
 </Item>
</AML>